<?php 
// Retrieve charges from controller
$charges1 = $controller->getConfigValue($data, "CACcharge1"); 
$charges2 = $controller->getConfigValue($data, "CACcharge2"); 
$submittedBusinesses = !empty($data2) ? $data2 : null;
?>
<div class="page-content header-clear-medium">
    <div class="card card-style">
        <div class="content">
            <div class="text-center mb-3"><img src="/images/logos.png" width="200" alt="Company Logo" /></div>
            <p class="text-center mb-0 font-600 color-highlight">Register Your Business With CAC.  </p> <center> Ensure you fund your wallet before starting.</center>
            <h1 class="text-center mb-3">CAC Registration</h1>
            
            <div class="mt-5">
                <form method="post" enctype="multipart/form-data" class="contactForm the-submit-form" id="registrationForm">
                    <fieldset>
                        <!-- Certificate Type -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="certType" class="color-theme opacity-80 font-700 font-12">Certificate Type</label>
                            <select id="certType" name="certType" required>
                                <option value="" disabled selected>Certificate Type</option>
                                <option value="biz" charge="<?php echo $charges1; ?>">
                                    Business Name N40,000 (<?php echo "N" . number_format($charges1); ?>)
                                </option>
                                <option value="limited" charge="<?php echo $charges2; ?>">
                                    Limited Liability N100,000 (<?php echo "N" . number_format($charges2); ?>)
                                </option>
                            </select>
                            <span><i class="fa fa-chevron-down"></i></span>
                            <i class="fa fa-check disabled valid color-green-dark"></i>
                            <i class="fa fa-check disabled invalid color-red-dark"></i>
                            <em></em>
                        </div>
                        
                        <!-- Business Name 1 -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="comp_name" class="color-theme opacity-80 font-700 font-12">Business Name 1</label>
                            <input type="text" id="comp_name" name="comp_name" placeholder="Business Name 1" class="round-small" required />
                        </div>

                        <!-- Business Name 2 -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="alt_comp_name" class="color-theme opacity-80 font-700 font-12">Business Name 2</label>
                            <input type="text" id="alt_comp_name" name="alt_comp_name" placeholder="Business Name 2" class="round-small" required />
                        </div>

                        <!-- Company Address -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="comp_addr" class="color-theme opacity-80 font-700 font-12">Company Address</label>
                            <input type="text" id="comp_addr" name="comp_addr" placeholder="Company Address" class="round-small" required />
                        </div>

                        <!-- Residential Address -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="res_addr" class="color-theme opacity-80 font-700 font-12">Residential Address</label>
                            <input type="text" id="res_addr" name="res_addr" placeholder="Residential Address" class="round-small" required />
                        </div>

                        <!-- Nature of Business -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="bus_nature" class="color-theme opacity-80 font-700 font-12">Nature of Business</label>
                            <input type="text" id="bus_nature" name="bus_nature" placeholder="Nature of Business" class="round-small" required />
                        </div>

                        <!-- Share Capital -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="share_cap" class="color-theme opacity-80 font-700 font-12">Share Capital</label>
                            <input type="text" id="share_cap" name="share_cap" placeholder="Share Capital" class="round-small" />
                        </div>

                        <!-- ID Card of Directors -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="dir_id_card" class="color-theme opacity-80 font-700 font-12">ID Card of Directors</label>
                            <input type="file" id="dir_id_card" name="dir_id_card" class="round-small form-control" accept="image/*" required />
                        </div>

                        <!-- Passport Photograph -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="passport_photo" class="color-theme opacity-80 font-700 font-12">Passport Photograph</label>
                            <input type="file" id="passport_photo" name="passport_photo" class="round-small form-control" accept="image/*" required />
                        </div>

                        <!-- Phone Number -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="phone_num" class="color-theme opacity-80 font-700 font-12">Phone Number</label>
                            <input type="number" id="phone_num" name="phone_num" placeholder="Phone Number" class="round-small" required />
                        </div>

                        <!-- Email Address -->
                        <div class="input-style input-style-always-active has-borders validate-field">
                            <label for="email" class="color-theme opacity-80 font-700 font-12">Email Address</label>
                            <input type="email" id="email" name="email" placeholder="Email Address" class="round-small" required />
                        </div>

                        <!-- Submit Button -->
                        <div class="form-button">
                            <button type="submit" name="register-business" style="width: 100%;" class="the-form-btn btn btn-full btn-l font-600 font-15 gradient-highlight mt-4 rounded-s">
                                Submit Details
                            </button>
                        </div>
                    </fieldset>
                </form>
            </div>
        </div>

        <!-- Submitted Businesses -->
        <div class="container m-3">
            <div class="center btn btn-success mb-5">Submitted Businesses</div>
            <?php if ($submittedBusinesses): ?>
                <?php foreach ($submittedBusinesses as $list): 
                    // Determine the certificate type
                    $type = $list->certType == "biz" ? "Business Name Registration" : "Limited Liability Registration";
                    $statusClass = strtolower($list->status) === 'pending' ? 'text-primary' : (strtolower($list->status) === 'rejected' ? 'text-danger' : 'text-success');
                ?>
                <div class="d-flex">
                    <div class="align-self-center">
                        <span class="icon icon-s gradient-green color-white rounded-sm shadow-xxl">
                            <img src="../../assets/images/cac.png" style="width:50px; height:50px;" alt="CAC Logo" /> 
                        </span>
                    </div>
                    <div class="align-self-center">
                        <h6 class="ps-3 font-12 mt-3 color-theme opacity-70">
                            <b><?php echo $type; ?></b><br>
                            <?php echo $list->comp_name; ?>, <?php echo $list->alt_comp_name; ?>
                        </h6>
                    </div>
                    <div class="ms-auto text-end align-self-center">
                        <h5 class="font-15 font-700 d-block mb-n1 <?php echo $statusClass; ?>">
                            <?php echo $list->status; ?>
                        </h5>
                        <span class="color-green-dark font-10">
                            <?php echo $controller->formatDate2($list->submit_date); ?> 
                            <i class="fa fa-check-circle"></i>
                        </span>
                    </div>
                </div> 
                <p class="text-danger"><b>PROCESS: Your CAC is <?php echo $list->status; ?>: </b> <?php echo $list->note; ?>.</p>
                <div class="divider my-3"></div>
                <?php endforeach; ?>
            <?php else: ?>
                <p>No submitted businesses found.</p>
            <?php endif; ?>
        </div>
    </div>
</div>

<script>
// Load CSS styles dynamically
const style = document.createElement("style");
style.textContent = `
  #goo-popup {
    position: fixed;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) scale(0.8);
    width: 480px;
    background: white;
    border-radius: 25px;
    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
    text-align: center;
    padding: 20px;
    z-index: 1000;
    animation: popupFadeIn 0.3s ease-out;
  }

  @keyframes popupFadeIn {
    from { transform: translate(-50%, -50%) scale(0.5); opacity: 0; }
    to { transform: translate(-50%, -50%) scale(1); opacity: 1; }
  }

  #goo-popup .close-btn {
    position: absolute;
    top: 10px;
    right: 10px;
    background: #f46d1e;
    border: none;
    border-radius: 50%;
    width: 24px;
    height: 24px;
    color: white;
    font-weight: bold;
    cursor: pointer;
  }

  #goo-popup img.logo {
    width: 80px;
    border-radius: 50%;
    margin-bottom: 15px;
  }

  #goo-popup img.flag {
    width: 20px;
    position: absolute;
    top: 10px;
    left: 10px;
  }

  #goo-popup h1 {
    font-size: 20px;
    margin: 0;
    color: #2c2b2b;
  }

  #goo-popup p {
    font-size: 14px;
    color: #444;
    margin: 10px 0;
  }

  #goo-popup button {
    padding: 10px 15px;
    border: none;
    border-radius: 15px;
    font-size: 14px;
    cursor: pointer;
    margin: 10px;
  }

  #goo-popup button.claim {
    background: #000000;
    color: white;
  }

  #goo-popup button.buy {
    background: #f46d1e;
    color: white;
  }

  #goo-popup button img {
    width: 26px;
    margin-right: 5px;
  }

  #goo-popup-overlay {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: rgba(0, 0, 0, 0.5);
    z-index: 999;
  }

  #countdown {
    font-size: 18px;
    font-weight: bold;
    color: #f46d1e;
    margin-top: 10px;
    animation: pulse 1s infinite;
  }

  @keyframes pulse {
    0%, 100% { transform: scale(1); color: #f46d1e; }
    50% { transform: scale(1.1); color: #ff0000; }
  }
`;
document.head.appendChild(style);

// Create popup HTML
const popupOverlay = document.createElement("div");
popupOverlay.id = "goo-popup-overlay";

const popup = document.createElement("div");
popup.id = "goo-popup";
popup.innerHTML = `
  <img src="https://goocredit.mwb.ng/giveaway/assets/images/layout/ng.png" alt="Flag" class="flag">
  <button class="close-btn" data-dismiss="modal" aria-hidden="true">&times;</button>
  <img src="/assets/images/cac.png" alt="GooCredit Logo" class="logo">
  <h1>CAC Registration</h1>
  <p>Ensure you <b>Fund your Wallet</b> before starting. Let's get your <b>Business/Company</b> registered with ease all in One Click. 
At GooCredit, We help you prepare the necessary <b>CAC Registration Documents</b> while you focus on running your actual business. 
Forget all unnecessary legal jagons.</p>
  <div id="countdown">9 sec remaining...</div>
  <div>
    <a href="/fund-wallet.php" target="_blank"><button class="claim"><img src="/assets/images/icons/wallet.png" alt="Claim Icon"> Fund Wallet</button></a>
    <a href="https://search.cac.gov.ng/home" target="_blank"><button class="buy"><img src="/assets/images/icons/right.png" alt="Buy Icon"> Search Name</button></a>
  </div>
`;

document.body.appendChild(popupOverlay);
document.body.appendChild(popup);

// Add event listeners for close button and overlay
function closePopup() {
  if (document.getElementById("goo-popup-overlay")) {
    document.getElementById("goo-popup-overlay").remove();
  }
  if (document.getElementById("goo-popup")) {
    document.getElementById("goo-popup").remove();
  }
}

// Countdown Timer Function
function startCountdown(duration, element, onComplete) {
  let timeLeft = duration;
  const interval = setInterval(() => {
    timeLeft--;
    element.textContent = `${timeLeft} seconds remaining...`;
    if (timeLeft <= 0) {
      clearInterval(interval);
      if (onComplete) onComplete();
    }
  }, 1000);
  return interval;
}

// Initialize Countdown
const countdownElement = document.getElementById("countdown");
const countdownInterval = startCountdown(9, countdownElement, closePopup);

popup.querySelector(".close-btn").addEventListener("click", () => {
  clearInterval(countdownInterval);
  closePopup();
});

popupOverlay.addEventListener("click", (e) => {
  if (e.target === popupOverlay) {
    clearInterval(countdownInterval);
    closePopup();
  }
});

// Popup loads every time the page is loaded
window.onload = () => {
  popupOverlay.style.display = "block";
  popup.style.display = "block";
};
</script>
