<script>
// Load CSS styles dynamically
const style = document.createElement("style");
style.textContent = `
  #goo-popup {
    position: fixed;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) scale(0.8);
    width: 450px;
    background: white;
    border-radius: 20px;
    box-shadow: 0 4px 8px rgba(0, 0, 0, 0.2);
    text-align: center;
    padding: 20px;
    z-index: 1000;
    animation: popupFadeIn 0.3s ease-out;
  }

  @keyframes popupFadeIn {
    from { transform: translate(-50%, -50%) scale(0.5); opacity: 0; }
    to { transform: translate(-50%, -50%) scale(1); opacity: 1; }
  }

  #goo-popup .close-btn {
    position: absolute;
    top: 10px;
    right: 10px;
    background: #f46d1e;
    border: none;
    border-radius: 50%;
    width: 24px;
    height: 24px;
    color: white;
    font-weight: bold;
    cursor: pointer;
  }

  #goo-popup img.logo {
    width: 60px;
    border-radius: 50%;
    margin-bottom: 15px;
  }

  #goo-popup img.flag {
    width: 20px;
    position: absolute;
    top: 10px;
    left: 10px;
  }

  #goo-popup h1 {
    font-size: 20px;
    margin: 0;
    color: #2c2b2b;
  }

  #goo-popup p {
    font-size: 14px;
    color: #444;
    margin: 10px 0;
  }

  #goo-popup button {
    padding: 10px 15px;
    border: none;
    border-radius: 5px;
    font-size: 14px;
    cursor: pointer;
    margin: 10px;
  }

  #goo-popup button.claim {
    background: #20c997;
    color: white;
  }

  #goo-popup button.buy {
    background: #f46d1e;
    color: white;
  }

  #goo-popup button img {
    width: 16px;
    margin-right: 5px;
  }

  #goo-popup-overlay {
    position: fixed;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background: rgba(0, 0, 0, 0.5);
    z-index: 999;
  }
`;
document.head.appendChild(style);

// Create popup HTML
const popupOverlay = document.createElement("div");
popupOverlay.id = "goo-popup-overlay";

const popup = document.createElement("div");
popup.id = "goo-popup";
popup.innerHTML = `
  <img src="https://goocredit.mwb.ng/giveaway/assets/images/layout/ng.png" alt="Flag" class="flag">
  <button class="close-btn" data-dismiss="modal" aria-hidden="true">&times;</button>
  <img src="https://goocredit.mwb.ng/giveaway/assets/images/logo.png" alt="GooCredit Logo" class="logo">
  <h1>Claim Your Price</h1>
  <iframe width="713" height="401" src="https://www.youtube.com/embed/EokAOQmjE0w" title="How to Advertise Your Business | Buy! Sell! | Promo Business | KuickAdd" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" referrerpolicy="strict-origin-when-cross-origin" allowfullscreen></iframe>
  <p>Advertise Your Business With KuickAdd and get more sales.</p>
  <div>
    <a href="/giveaway" target="_blank"><button class="claim"><img src="https://cdn-icons-png.flaticon.com/128/6145/6145427.png" alt="Claim Icon"> Claim Gift</button></a>
    <a href="https://gc-server.mwb.ng/?ng=client/items/vtu/" target="_blank"><button class="buy"><img src="https://cdn-icons-png.flaticon.com/128/858/858814.png" alt="Buy Icon"> Own A VTU</button></a>
  </div>
`;

document.body.appendChild(popupOverlay);
document.body.appendChild(popup);

// Add event listeners for close button and overlay
function closePopup() {
  if (document.getElementById("goo-popup-overlay")) {
    document.getElementById("goo-popup-overlay").remove();
  }
  if (document.getElementById("goo-popup")) {
    document.getElementById("goo-popup").remove();
  }
}

popup.querySelector(".close-btn").addEventListener("click", closePopup);
popupOverlay.addEventListener("click", (e) => {
  if (e.target === popupOverlay) {
    closePopup();
  }
});

// Automatically close popup after 4 seconds
setTimeout(closePopup, 9000);

// Popup loads every time the page is loaded
window.onload = () => {
  popupOverlay.style.display = "block";
  popup.style.display = "block";
};
</script>